﻿Imports Microsoft.VisualBasic
Imports System
Imports System.Collections.Generic
Imports System.Linq
Imports System.Text
Imports System.Windows
Imports System.Windows.Controls
Imports System.Windows.Data
Imports System.Windows.Documents
Imports System.Windows.Input
Imports System.Windows.Media
Imports System.Windows.Media.Imaging
Imports System.Windows.Navigation
Imports System.Windows.Shapes
Imports Syncfusion.Windows.Tools.Controls
Imports Microsoft.Win32
Imports System.IO
Imports Syncfusion.Windows.Shared

Namespace CustomizedRibbon
    ' <summary>
    'Interaction logic for MainWindow.xaml
    '</summary>
    Partial Public Class MainWindow
        Inherits RibbonWindow

        Private Function FindLogicalRoot(obj As DependencyObject) As DependencyObject
            If obj Is Nothing Then
                Return Nothing
            Else
                Dim parent = LogicalTreeHelper.GetParent(obj)
                Return If(parent IsNot Nothing, FindLogicalRoot(parent), obj)
            End If
        End Function

        Public Sub New()
            InitializeComponent()
#If Framework4_0 Then
            'Enables touch manipulation.
            rte.IsManipulationEnabled = True
#End If

            AddHandler rte.FileOpening, Function(sender, e) AnonymousMethod1(sender, e)

            AddHandler rte.FileSaving, Function(sender, e) AnonymousMethod2(sender, e)

            DataContext = rte
            SkinStorage.SetVisualStyle(Me, "Office2013")

            InitCustomRibbonHelper()
        End Sub


        Private Function AnonymousMethod1(ByVal sender As Object, ByVal e As Object) As Object
            rte.Document = DocxImporting.ConvertToDocumentAdv(e.DocumentStream, e.FormatType)
            Return Nothing
        End Function

        Private Function AnonymousMethod2(ByVal sender As Object, ByVal e As Object) As Object
            DocxExporting.ConvertToDocument(rte.Document, e.DoucmentStream, e.FormatType)
            Return Nothing
        End Function

        Private Sub InitCustomRibbonHelper()
            ' Customizing RichTextRibbon
            AddFontFamily()

            AddHandler PART_FontFamilyCombo.DropDownClosed, Function(sender, e) AnonymousMethod3(sender, e)
            AddHandler PART_FontSizeCombo.DropDownClosed, Function(sender, e) AnonymousMethod4(sender, e)
            AddHandler PART_Colorpicker.ColorChanged, Function(sender, e) AnonymousMethod5(sender, e)
            AddHandler PART_GrowFont.Click, Function(sender, e) AnonymousMethod6(sender, e)
            AddHandler PART_ShrinkFont.Click, Function(sender, e) AnonymousMethod7(sender, e)
            AddHandler PART_TablePicker.Click, Function(sender, e) AnonymousMethod8(sender, e)
            AddHandler PART_PrintDocument.Click, Function(sender, e) AnonymousMethod9(sender, e)
            AddHandler PART_Open.Click, Function(sender, e) AnonymousMethod10(sender, e)
            AddHandler PART_InsertTable.Click, Function(sender, e) AnonymousMethod11(sender, e)
            AddHandler PART_NewDocument_BackStage.Click, Function(sender, e) AnonymousMethod12(sender, e)
            AddHandler PART_CreateDocument.Click, Function(sender, e) AnonymousMethod13(sender, e)
            AddHandler PART_FontColorSplitButton.Click, Function(sender, e) AnonymousMethod14(sender, e)
            AddHandler ribbon.BackStageClosed, Function(sender, e) AnonymousMethod15(sender, e)
            AddHandler ribbon.Loaded, Function(sender, e) AnonymousMethod16(sender, e)
        End Sub

        Private Function AnonymousMethod3(ByVal sender As Object, ByVal e As Object) As Object
            RichTextBoxAdv.ChangeFontFamily.Execute(PART_FontFamilyCombo.SelectedItem, Nothing)
            Return Nothing
        End Function

        Private Function AnonymousMethod4(ByVal sender As Object, ByVal e As Object) As Object
            RichTextBoxAdv.ChangeFontSize.Execute(PART_FontSizeCombo.SelectedItem, Nothing)
            Return Nothing
        End Function

        Private Function AnonymousMethod5(ByVal sender As Object, ByVal e As Object) As Object
            rte.Selection.ChangeForeground(PART_Colorpicker.Color)
            Dim splitbutton As SplitButton = DirectCast(PART_Colorpicker.Parent, SplitButton)
            splitbutton.IsDropDownOpen = False
            Return Nothing
        End Function

        Private Function AnonymousMethod6(ByVal sender As Object, ByVal e As Object) As Object
            If PART_FontSizeCombo.SelectedIndex < PART_FontSizeCombo.Items.Count - 1 Then
                PART_FontSizeCombo.SelectedIndex += 1
                rte.Selection.ChangeFontSize(Integer.Parse((PART_FontSizeCombo.SelectedItem).ToString()))
            Else
                rte.Selection.ChangeFontSize(rte.CurrentInlineStyle.FontSize + 10)
            End If
            Return Nothing
        End Function

        Private Function AnonymousMethod7(ByVal sender As Object, ByVal e As Object) As Object
            If PART_FontSizeCombo.SelectedIndex > 0 Then
                PART_FontSizeCombo.SelectedIndex -= 1
                rte.Selection.ChangeFontSize(Integer.Parse((PART_FontSizeCombo.SelectedItem).ToString()))
            Else
                If rte.CurrentInlineStyle.FontSize > 1 Then
                    rte.Selection.ChangeFontSize(rte.CurrentInlineStyle.FontSize - 1)
                End If
            End If
            Return Nothing
        End Function

        Private Function AnonymousMethod8(ByVal sender As Object, ByVal e As Object) As Object

            rte.InsertTableInBlocks(PART_TablePicker.SelectedCell.Row + 1, PART_TablePicker.SelectedCell.Column + 1)

            Dim obj As Object = PART_TablePicker.Parent

            While Not (TypeOf obj Is DropDownButton)
                obj = TryCast(obj, FrameworkElement).Parent
            End While
            Dim dropdown As DropDownButton = TryCast(obj, DropDownButton)
            dropdown.IsDropDownOpen = False
            Return Nothing
        End Function

        Private Function AnonymousMethod9(ByVal sender As Object, ByVal e As Object) As Object
            ribbon.BackStageButton.IsOpen = False
            Return Nothing
        End Function

        Private Function AnonymousMethod10(ByVal sender As Object, ByVal e As Object) As Object
            ribbon.BackStageButton.IsOpen = False
            Return Nothing
        End Function

        Private Function AnonymousMethod11(ByVal sender As Object, ByVal e As Object) As Object
            Dim obj As Object = PART_TablePicker.Parent

            While Not (TypeOf obj Is DropDownButton)
                obj = TryCast(obj, FrameworkElement).Parent
            End While
            Dim dropdown As DropDownButton = TryCast(obj, DropDownButton)
            dropdown.IsDropDownOpen = False
            Return Nothing
        End Function

        Private Function AnonymousMethod12(ByVal sender As Object, ByVal e As Object) As Object
            ribbon.BackStageButton.IsOpen = False
            rte.DocumentTitle = "Untitled"
            Return Nothing
        End Function

        Private Function AnonymousMethod13(ByVal sender As Object, ByVal e As Object) As Object
            ribbon.BackStageButton.IsOpen = False
            rte.DocumentTitle = "Untitled"
            Return Nothing
        End Function

        Private Function AnonymousMethod14(ByVal sender As Object, ByVal e As Object) As Object
            rte.Selection.ChangeForeground(PART_Colorpicker.Color)
            Return Nothing
        End Function

        Private Function AnonymousMethod15(ByVal sender As Object, ByVal e As Object) As Object
            rte.Focus()
            Return Nothing
        End Function

        Private Function AnonymousMethod16(ByVal sender As Object, ByVal e As Object) As Object
            Dim window As Window = TryCast(Me, Window)
            If window IsNot Nothing Then
                window.CommandBindings.Add(New CommandBinding(RichTextBoxAdv.Save, AddressOf SaveExecute))
                window.CommandBindings.Add(New CommandBinding(RichTextBoxAdv.SaveAs, AddressOf SaveAsExecute))
                window.CommandBindings.Add(New CommandBinding(RichTextBoxAdv.Print, AddressOf PrintExecute))
                window.CommandBindings.Add(New CommandBinding(RichTextBoxAdv.Open, AddressOf OpenExecute))
                window.CommandBindings.Add(New CommandBinding(RichTextBoxAdv.[New], AddressOf NewExecute))
            End If
            If rte IsNot Nothing Then
                rte.Focus()
            End If
            Return Nothing
        End Function

        Public Property FontFamilySource() As FontFamilies
            Get
                Return DirectCast(GetValue(FontFamilySourceProperty), FontFamilies)
            End Get
            Set(value As FontFamilies)
                SetValue(FontFamilySourceProperty, value)
            End Set
        End Property

        ' Using a DependencyProperty as the backing store for FontFamilySource.
        Public Shared ReadOnly FontFamilySourceProperty As DependencyProperty = DependencyProperty.Register("FontFamilySource", GetType(FontFamilies), GetType(MainWindow), New PropertyMetadata(New FontFamilies()))
        Public Shared ReadOnly FontSizeSourceProperty As DependencyProperty = DependencyProperty.Register("FontSizeSource", GetType(Double()), GetType(MainWindow), New PropertyMetadata(New Double() {8, 9, 10, 11, 12, 14, _
            16, 18, 20, 24, 26, 28, _
            36, 48, 72}))

        Public Property FontSizeSource() As Double()
            Get
                Return DirectCast(GetValue(FontSizeSourceProperty), Double())
            End Get
            Set(value As Double())
                SetValue(FontSizeSourceProperty, value)
            End Set
        End Property
        Public Property PageCount() As Integer
            Get
                Return CInt(GetValue(PageCountProperty))
            End Get
            Set(value As Integer)
                SetValue(PageCountProperty, value)
            End Set
        End Property

        ' Using a DependencyProperty as the backing store for PageCount.  This enables animation, styling, binding, etc...
        Public Shared ReadOnly PageCountProperty As DependencyProperty = DependencyProperty.Register("PageCount", GetType(Integer), GetType(MainWindow), New PropertyMetadata(0))

        Private Sub SaveExecute(sender As Object, e As ExecutedRoutedEventArgs)
            If rte IsNot Nothing Then
                rte.SaveDocument(String.Empty)
                rte.Focus()
            End If
        End Sub

        Private Sub SaveAsExecute(sender As Object, e As ExecutedRoutedEventArgs)
            Dim extension As String = String.Empty
            If e.Parameter Is Nothing Then
                extension = ".docx"
            Else
                extension = e.Parameter.ToString()
            End If
            If rte IsNot Nothing Then
                rte.SaveDocument(extension)
            End If
        End Sub

        Private Sub PrintExecute(sender As Object, e As ExecutedRoutedEventArgs)
            If rte IsNot Nothing Then
                rte.PrintDocument()
                rte.Focus()
            End If
        End Sub

        Private Sub NewExecute(sender As Object, e As ExecutedRoutedEventArgs)
            If rte IsNot Nothing Then
                rte.CreateEmptyDocument()
                rte.Focus()
            End If
        End Sub

        Private Sub OpenExecute(sender As Object, e As ExecutedRoutedEventArgs)
            If rte IsNot Nothing Then
                rte.OpenDocument()
                rte.Focus()
            End If
        End Sub

        Private Sub AddFontFamily()
            FontFamilySource = New FontFamilies()
            For Each fontfamily As FontFamily In Fonts.SystemFontFamilies
                FontFamilySource.Add(fontfamily)
            Next
        End Sub

    End Class

    Public Class FontFamilies
        Inherits List(Of FontFamily)
        Public Sub New()
            For Each fontfamily As FontFamily In Fonts.SystemFontFamilies
                Add(fontfamily)
            Next
        End Sub
    End Class
    Public Class ZoomFactorInPercentage
        Implements IValueConverter
        Public Function Convert(ByVal value As Object, ByVal targetType As Type, ByVal parameter As Object, ByVal culture As System.Globalization.CultureInfo) As Object Implements IValueConverter.Convert
            Dim factor As Double = Math.Round(System.Convert.ToDouble(value), 2)
            If factor = 0 Then
                factor = 0.1
            End If
            Return CInt(Fix(factor * 100 * 4))
        End Function

        Public Function ConvertBack(ByVal value As Object, ByVal targetType As Type, ByVal parameter As Object, ByVal culture As System.Globalization.CultureInfo) As Object Implements IValueConverter.ConvertBack
            Throw New NotImplementedException()
        End Function
    End Class

    Public Class RunAdv
        Inherits Run

        Public Sub New()
        End Sub

        Public Property RunText() As String
            Get
                Return DirectCast(GetValue(RunTextProperty), String)
            End Get
            Set(value As String)
                SetValue(RunTextProperty, value)
            End Set
        End Property

        ' Using a DependencyProperty as the backing store for RunText.  This enables animation, styling, binding, etc...
        Public Shared ReadOnly RunTextProperty As DependencyProperty = DependencyProperty.Register("RunText", GetType(String), GetType(RunAdv), New PropertyMetadata(String.Empty, New PropertyChangedCallback(AddressOf OnRunTextChanged)))

        Private Shared Sub OnRunTextChanged(d As DependencyObject, e As DependencyPropertyChangedEventArgs)
            Dim runadv As RunAdv = TryCast(d, RunAdv)
            runadv.OnRunTextChanged(e)
        End Sub

        Private Sub OnRunTextChanged(e As DependencyPropertyChangedEventArgs)
            MyBase.Text = DirectCast(e.NewValue, String)
        End Sub
    End Class

End Namespace
