﻿Imports Microsoft.VisualBasic
Imports System
Imports System.Collections.Generic
Imports System.Linq
Imports System.Text
Imports System.Windows.Interactivity
Imports Syncfusion.Windows.Tools.Controls
Imports System.Windows.Media
Imports System.Windows.Controls
Imports System.Windows
Imports System.ComponentModel

Namespace CustomizedRibbon
    Public Class SelectionChangedAction
        Inherits TargetedTriggerAction(Of RichTextBoxAdv)
        Public Property Element() As UIElement
            Get
                Return CType(GetValue(ElementProperty), UIElement)
            End Get
            Set(ByVal value As UIElement)
                SetValue(ElementProperty, value)
            End Set
        End Property

        ' Using a DependencyProperty as the backing store for Element.  This enables animation, styling, binding, etc...
        Public Shared ReadOnly ElementProperty As DependencyProperty = DependencyProperty.Register("Element", GetType(UIElement), GetType(SelectionChangedAction), New UIPropertyMetadata(Nothing))


        Protected Overrides Sub Invoke(ByVal parameter As Object)
            Dim rte As RichTextBoxAdv = TryCast(Element, RichTextBoxAdv)
            Dim args As System.Windows.Controls.SelectionChangedEventArgs = TryCast(parameter, System.Windows.Controls.SelectionChangedEventArgs)
            If rte IsNot Nothing AndAlso args IsNot Nothing Then
                If args.AddedItems(0).ToString() = "Transparent" Then
                    rte.Background = New SolidColorBrush(Color.FromArgb(255, 214, 245, 146))
                Else
                    rte.Background = Brushes.White
                End If
            End If
        End Sub
    End Class
End Namespace
